/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs

/* First part of user prologue.  */
#line 19 "dlls/jscript/parser.y"


#include "jscript.h"
#include "engine.h"
#include "parser.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(jscript);

static int parser_error(unsigned*,parser_ctx_t*,const char*);
static void set_error(parser_ctx_t*,unsigned,HRESULT);
static BOOL explicit_error(parser_ctx_t*,void*,WCHAR);
static BOOL allow_auto_semicolon(parser_ctx_t*);

typedef struct _statement_list_t {
    statement_t *head;
    statement_t *tail;
} statement_list_t;

static literal_t *new_string_literal(parser_ctx_t*,jsstr_t*);
static literal_t *new_null_literal(parser_ctx_t*);

typedef struct _property_list_t {
    property_definition_t *head;
    property_definition_t *tail;
} property_list_t;

static property_definition_t *new_property_definition(parser_ctx_t *ctx, property_definition_type_t,
                                                      literal_t *name, expression_t *value);
static property_list_t *new_property_list(parser_ctx_t*,property_definition_t*);
static property_list_t *property_list_add(parser_ctx_t*,property_list_t*,property_definition_t*);

typedef struct _element_list_t {
    array_element_t *head;
    array_element_t *tail;
} element_list_t;

static element_list_t *new_element_list(parser_ctx_t*,int,expression_t*);
static element_list_t *element_list_add(parser_ctx_t*,element_list_t*,int,expression_t*);

typedef struct _argument_list_t {
    argument_t *head;
    argument_t *tail;
} argument_list_t;

static argument_list_t *new_argument_list(parser_ctx_t*,expression_t*);
static argument_list_t *argument_list_add(parser_ctx_t*,argument_list_t*,expression_t*);

typedef struct _case_list_t {
    case_clausule_t *head;
    case_clausule_t *tail;
} case_list_t;

static catch_block_t *new_catch_block(parser_ctx_t*,const WCHAR*,statement_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,unsigned,expression_t*,statement_list_t*);
static case_list_t *new_case_list(parser_ctx_t*,case_clausule_t*);
static case_list_t *case_list_add(parser_ctx_t*,case_list_t*,case_clausule_t*);
static case_clausule_t *new_case_block(parser_ctx_t*,case_list_t*,case_clausule_t*,case_list_t*);

typedef struct _variable_list_t {
    variable_declaration_t *head;
    variable_declaration_t *tail;
} variable_list_t;

static variable_declaration_t *new_variable_declaration(parser_ctx_t*,const WCHAR*,expression_t*);
static variable_list_t *new_variable_list(parser_ctx_t*,variable_declaration_t*);
static variable_list_t *variable_list_add(parser_ctx_t*,variable_list_t*,variable_declaration_t*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t,unsigned);
static statement_t *new_block_statement(parser_ctx_t*,unsigned,statement_list_t*);
static statement_t *new_var_statement(parser_ctx_t*,unsigned,variable_list_t*);
static statement_t *new_expression_statement(parser_ctx_t*,unsigned,expression_t*);
static statement_t *new_if_statement(parser_ctx_t*,unsigned,expression_t*,statement_t*,statement_t*);
static statement_t *new_while_statement(parser_ctx_t*,unsigned,BOOL,expression_t*,statement_t*);
static statement_t *new_for_statement(parser_ctx_t*,unsigned,variable_list_t*,expression_t*,expression_t*,unsigned,
                                      expression_t*,unsigned,statement_t*);
static statement_t *new_forin_statement(parser_ctx_t*,unsigned,variable_declaration_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_continue_statement(parser_ctx_t*,unsigned,const WCHAR*);
static statement_t *new_break_statement(parser_ctx_t*,unsigned,const WCHAR*);
static statement_t *new_return_statement(parser_ctx_t*,unsigned,expression_t*);
static statement_t *new_with_statement(parser_ctx_t*,unsigned,expression_t*,statement_t*);
static statement_t *new_labelled_statement(parser_ctx_t*,unsigned,const WCHAR*,statement_t*);
static statement_t *new_switch_statement(parser_ctx_t*,unsigned,expression_t*,case_clausule_t*);
static statement_t *new_throw_statement(parser_ctx_t*,unsigned,expression_t*);
static statement_t *new_try_statement(parser_ctx_t*,statement_t*,catch_block_t*,statement_t*,unsigned);

struct statement_list_t {
   statement_t *head;
   statement_t *tail;
};

static statement_list_t *new_statement_list(parser_ctx_t*,statement_t*);
static statement_list_t *statement_list_add(statement_list_t*,statement_t*);

typedef struct _parameter_list_t {
    parameter_t *head;
    parameter_t *tail;
} parameter_list_t;

static parameter_list_t *new_parameter_list(parser_ctx_t*,const WCHAR*);
static parameter_list_t *parameter_list_add(parser_ctx_t*,parameter_list_t*,const WCHAR*);

static void *new_expression(parser_ctx_t *ctx,expression_type_t,size_t);
static expression_t *new_function_expression(parser_ctx_t*,const WCHAR*,parameter_list_t*,
        source_elements_t*,const WCHAR*,const WCHAR*,DWORD);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_conditional_expression(parser_ctx_t*,expression_t*,expression_t*,expression_t*);
static expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);
static expression_t *new_new_expression(parser_ctx_t*,expression_t*,argument_list_t*);
static expression_t *new_call_expression(parser_ctx_t*,expression_t*,argument_list_t*);
static expression_t *new_identifier_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_literal_expression(parser_ctx_t*,literal_t*);
static expression_t *new_array_literal_expression(parser_ctx_t*,element_list_t*,int);
static expression_t *new_prop_and_value_expression(parser_ctx_t*,property_list_t*);

static source_elements_t *new_source_elements(parser_ctx_t*);
static source_elements_t *source_elements_add_statement(source_elements_t*,statement_t*);

#define YYLTYPE unsigned
#define YYLLOC_DEFAULT(Cur, Rhs, N) Cur = YYRHSLOC((Rhs), (N) ? 1 : 0)


#line 200 "dlls/jscript/parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_PARSER_DLLS_JSCRIPT_PARSER_TAB_H_INCLUDED
# define YY_PARSER_DLLS_JSCRIPT_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    kBREAK = 258,
    kCASE = 259,
    kCATCH = 260,
    kCONTINUE = 261,
    kDEFAULT = 262,
    kDELETE = 263,
    kDO = 264,
    kELSE = 265,
    kFUNCTION = 266,
    kIF = 267,
    kFINALLY = 268,
    kFOR = 269,
    kGET = 270,
    kIN = 271,
    kSET = 272,
    kINSTANCEOF = 273,
    kNEW = 274,
    kNULL = 275,
    kRETURN = 276,
    kSWITCH = 277,
    kTHIS = 278,
    kTHROW = 279,
    kTRUE = 280,
    kFALSE = 281,
    kTRY = 282,
    kTYPEOF = 283,
    kVAR = 284,
    kVOID = 285,
    kWHILE = 286,
    kWITH = 287,
    tANDAND = 288,
    tOROR = 289,
    tINC = 290,
    tDEC = 291,
    tHTMLCOMMENT = 292,
    kDIVEQ = 293,
    kDCOL = 294,
    tIdentifier = 295,
    tAssignOper = 296,
    tEqOper = 297,
    tShiftOper = 298,
    tRelOper = 299,
    tNumericLiteral = 300,
    tBooleanLiteral = 301,
    tStringLiteral = 302,
    LOWER_THAN_ELSE = 303
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 149 "dlls/jscript/parser.y"

    int                     ival;
    jsstr_t                 *str;
    literal_t               *literal;
    struct _argument_list_t *argument_list;
    case_clausule_t         *case_clausule;
    struct _case_list_t     *case_list;
    catch_block_t           *catch_block;
    struct _element_list_t  *element_list;
    expression_t            *expr;
    const WCHAR            *identifier;
    struct _parameter_list_t *parameter_list;
    struct _property_list_t *property_list;
    property_definition_t   *property_definition;
    source_elements_t       *source_elements;
    statement_t             *statement;
    struct _statement_list_t *statement_list;
    struct _variable_list_t *variable_list;
    variable_declaration_t  *variable_declaration;

#line 322 "dlls/jscript/parser.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int parser_parse (parser_ctx_t *ctx);

#endif /* !YY_PARSER_DLLS_JSCRIPT_PARSER_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1379

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  71
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  98
/* YYNRULES -- Number of rules.  */
#define YYNRULES  253
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  452

#define YYUNDEFTOK  2
#define YYMAXUTOK   303


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    65,     2,     2,     2,    63,    58,     2,
      69,    70,    61,    59,    51,    60,    68,    62,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    54,    53,
       2,    52,     2,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    66,     2,    67,    57,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    49,    56,    50,    64,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   255,   255,   258,   259,   263,   264,   269,   271,   273,
     278,   282,   283,   288,   289,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     311,   312,   317,   318,   322,   323,   327,   332,   333,   338,
     340,   345,   350,   355,   356,   360,   365,   366,   370,   375,
     379,   384,   386,   391,   393,   396,   398,   395,   402,   404,
     401,   407,   409,   414,   419,   424,   429,   434,   439,   444,
     446,   451,   452,   456,   457,   462,   467,   472,   477,   478,
     479,   484,   489,   493,   494,   497,   498,   502,   503,   508,
     509,   513,   515,   519,   520,   524,   525,   527,   532,   534,
     536,   541,   542,   547,   549,   554,   555,   560,   562,   567,
     568,   573,   575,   580,   581,   586,   588,   593,   594,   599,
     601,   606,   607,   612,   614,   619,   620,   625,   626,   631,
     632,   634,   636,   641,   642,   644,   649,   650,   655,   657,
     659,   664,   665,   667,   669,   674,   675,   677,   678,   680,
     681,   682,   683,   684,   685,   689,   691,   693,   699,   700,
     704,   705,   709,   710,   711,   713,   715,   720,   722,   724,
     726,   731,   732,   736,   737,   742,   743,   744,   745,   746,
     747,   751,   752,   753,   754,   759,   761,   766,   767,   771,
     772,   776,   777,   779,   791,   792,   797,   799,   801,   805,
     810,   811,   812,   816,   817,   821,   822,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   867,   868,   869,
     870,   871,   873,   878,   879,   880,   883,   884,   887,   888,
     891,   892,   895,   896
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "kBREAK", "kCASE", "kCATCH", "kCONTINUE",
  "kDEFAULT", "kDELETE", "kDO", "kELSE", "kFUNCTION", "kIF", "kFINALLY",
  "kFOR", "kGET", "kIN", "kSET", "kINSTANCEOF", "kNEW", "kNULL", "kRETURN",
  "kSWITCH", "kTHIS", "kTHROW", "kTRUE", "kFALSE", "kTRY", "kTYPEOF",
  "kVAR", "kVOID", "kWHILE", "kWITH", "tANDAND", "tOROR", "tINC", "tDEC",
  "tHTMLCOMMENT", "kDIVEQ", "kDCOL", "tIdentifier", "tAssignOper",
  "tEqOper", "tShiftOper", "tRelOper", "tNumericLiteral",
  "tBooleanLiteral", "tStringLiteral", "LOWER_THAN_ELSE", "'{'", "'}'",
  "','", "'='", "';'", "':'", "'?'", "'|'", "'^'", "'&'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "'~'", "'!'", "'['", "']'", "'.'", "'('", "')'",
  "$accept", "Program", "HtmlComment", "SourceElements",
  "FunctionExpression", "FunctionBody", "FormalParameterList",
  "FormalParameterList_opt", "Statement", "StatementList",
  "StatementList_opt", "Block", "VariableStatement",
  "VariableDeclarationList", "VariableDeclarationListNoIn",
  "VariableDeclaration", "VariableDeclarationNoIn", "Initialiser_opt",
  "Initialiser", "InitialiserNoIn_opt", "InitialiserNoIn",
  "EmptyStatement", "ExpressionStatement", "IfStatement",
  "IterationStatement", "$@1", "$@2", "$@3", "$@4", "ContinueStatement",
  "BreakStatement", "ReturnStatement", "WithStatement",
  "LabelledStatement", "SwitchStatement", "CaseBlock", "CaseClausules_opt",
  "CaseClausules", "CaseClausule", "DefaultClausule", "ThrowStatement",
  "TryStatement", "Catch", "Finally", "Expression_opt", "Expression_err",
  "Expression", "ExpressionNoIn_opt", "ExpressionNoIn", "AssignOper",
  "AssignmentExpression", "AssignmentExpressionNoIn",
  "ConditionalExpression", "ConditionalExpressionNoIn",
  "LogicalORExpression", "LogicalORExpressionNoIn", "LogicalANDExpression",
  "LogicalANDExpressionNoIn", "BitwiseORExpression",
  "BitwiseORExpressionNoIn", "BitwiseXORExpression",
  "BitwiseXORExpressionNoIn", "BitwiseANDExpression",
  "BitwiseANDExpressionNoIn", "EqualityExpression",
  "EqualityExpressionNoIn", "RelationalExpression",
  "RelationalExpressionNoIn", "ShiftExpression", "AdditiveExpression",
  "MultiplicativeExpression", "UnaryExpression", "PostfixExpression",
  "LeftHandSideExpression", "NewExpression", "MemberExpression",
  "CallExpression", "Arguments", "ArgumentList", "PrimaryExpression",
  "ArrayLiteral", "ElementList", "Elision", "Elision_opt", "ObjectLiteral",
  "PropertyNameAndValueList", "PropertyDefinition", "GetterSetterMethod",
  "PropertyName", "Identifier_opt", "IdentifierName",
  "ReservedAsIdentifier", "Literal", "BooleanLiteral", "semicolon_opt",
  "left_bracket", "right_bracket", "semicolon", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   123,
     125,    44,    61,    59,    58,    63,   124,    94,    38,    43,
      45,    42,    47,    37,   126,    33,    91,    93,    46,    40,
      41
};
# endif

#define YYPACT_NINF (-350)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-237)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -350,     2,   642,  -350,    55,    55,  1131,   834,    25,    36,
      36,   144,  -350,  1131,    36,  -350,  1131,  -350,  -350,    10,
    1131,    70,  1131,    36,    36,  1131,  1131,  -350,  -350,    81,
    -350,  -350,  -350,   578,  -350,  1131,  1131,  -350,  1131,  1131,
     121,  1131,  -350,   481,  -350,  -350,  -350,  -350,  -350,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,    23,
    -350,  -350,    54,    40,    88,   109,   113,   133,   101,   136,
     209,   238,  -350,  -350,   229,  -350,   166,   224,  -350,  -350,
    -350,  -350,  -350,  -350,    50,    50,  -350,  1198,  -350,  -350,
     247,   168,  -350,    32,  -350,   163,   443,   953,  -350,   166,
      50,   156,  1131,    23,   706,    80,  -350,   153,   106,  -350,
    -350,   443,  1131,  -350,  -350,   834,   141,  -350,  -350,   154,
    -350,  1131,   834,  -350,     9,    27,  -350,    35,  1294,  -350,
    1294,  -350,   144,   157,  1012,    60,   160,  1131,   195,   204,
      10,  1131,    70,  1131,    74,    85,    81,   207,   217,   512,
    -350,   770,   236,  -350,   222,  -350,  -350,  -350,  -350,  -350,
    -350,  -350,  -350,   125,   129,  1131,   -17,  -350,  1131,  -350,
    -350,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  -350,  -350,  -350,
    -350,  1131,  1131,  1131,  1339,   893,  -350,  1131,  1339,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,  -350,    36,   223,   163,
    -350,   227,    22,  -350,    22,   156,   249,  -350,   255,  -350,
    -350,   128,   274,   252,   253,   251,   269,    28,   136,   221,
    -350,  -350,    17,  -350,  -350,    36,    10,   299,  -350,  1131,
    -350,  -350,    70,  -350,    22,    17,  -350,  -350,  -350,    36,
      36,  -350,  -350,  -350,  1246,  1131,   263,  -350,  -350,  -350,
    -350,  -350,  -350,    40,   264,    88,   109,   113,   133,   101,
     136,   136,   136,   209,   238,   238,  -350,  -350,  -350,  -350,
    -350,   135,  -350,  -350,  -350,    91,   185,  -350,   443,    36,
      22,   277,  -350,  -350,   270,   834,   268,   271,   305,    53,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
     443,  1131,  1131,   275,   285,  -350,  -350,  -350,  -350,   834,
     834,  -350,   163,  -350,  -350,  -350,  -350,   278,  1071,  1131,
    -350,  1131,  -350,  -350,    22,   163,   279,  -350,  -350,   316,
    1131,  -350,  -350,   249,    53,   443,  -350,  -350,  1131,  -350,
     239,   274,   280,   252,   253,   251,   269,    28,   136,   136,
      22,  -350,  -350,   327,  -350,    22,  -350,  -350,    22,  -350,
    -350,  -350,  -350,    50,    22,  -350,   834,   282,   834,  -350,
    -350,  1131,    22,  -350,  1131,   834,  1131,    41,   327,  -350,
      10,   284,  -350,   286,   289,  -350,  -350,  -350,   834,    53,
    -350,  -350,   150,   290,  -350,   327,  -350,  -350,  -350,  -350,
    -350,    53,  -350,  1131,   834,   834,   293,   295,   296,  1131,
      22,   834,  -350,  -350,  -350,  -350,  -350,    22,   834,   834,
    -350,  -350
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     0,     4,     1,   203,   203,     0,     0,     0,     0,
       0,     0,   237,    83,     0,   175,     0,   243,   244,     0,
       0,     0,     0,     0,     0,     0,     0,     3,   242,   176,
     239,   245,   240,     0,    49,     0,     0,   241,     0,     0,
     189,     0,     2,    18,     6,    15,    16,    17,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     0,
      87,    95,   101,   105,   109,   113,   117,   121,   125,   129,
     136,   138,   141,   145,   155,   158,   160,   159,   162,   178,
     179,   177,   238,   204,     0,     0,   176,     0,   163,   146,
     155,     0,   249,     0,   248,    13,     0,    89,   161,   160,
       0,    84,     0,     0,     0,     0,   148,    43,     0,    37,
     147,     0,     0,   149,   150,     0,   203,   208,   209,   203,
     211,   212,   213,   214,     0,     0,   216,     0,   219,   221,
     226,   222,   223,   237,    83,     0,   175,   229,   243,   244,
     231,   232,   233,   234,     0,     0,   176,   239,   240,    35,
      30,     0,     0,   194,     0,   200,   206,   151,   152,   153,
     154,   187,   181,     0,   190,     0,     0,   247,     0,   246,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   156,   157,    94,
      93,     0,     0,     0,     0,     0,   167,     0,     0,   168,
      64,    63,   207,   210,   212,   213,   218,   220,   217,   223,
     224,   225,   227,   228,   229,   230,   215,   231,   232,   233,
     234,   235,   236,   205,   202,   201,   191,     0,     0,    13,
      11,    14,     0,    86,     0,    85,     0,    55,    90,    91,
      98,   103,   107,   111,   115,   119,   123,   127,   133,   155,
     166,    65,     0,    77,    35,     0,     0,    78,    79,     0,
      41,    44,     0,    36,     0,     0,    67,   219,   226,     0,
       0,    34,    31,   192,     0,     0,   189,   183,   188,   182,
     185,   180,    88,   106,     0,   110,   114,   118,   122,   126,
     132,   131,   130,   137,   139,   140,   142,   143,   144,    96,
      97,     0,   165,   171,   173,     0,     0,   170,     0,     0,
       0,     0,   251,   250,     0,     0,    46,    58,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,    80,    45,    38,     0,
       0,   197,    13,   198,   193,   195,   196,   190,     0,     0,
     164,     0,   172,   169,     0,    13,     0,    12,     5,    52,
       0,    42,    47,     0,     0,     0,   253,   252,    83,    92,
     155,   108,     0,   112,   116,   120,   124,   128,   135,   134,
       0,    99,   100,    71,    68,     0,    54,    66,     0,   184,
     186,   102,   174,     0,     0,     5,    10,     0,     0,    48,
      40,    83,     0,    56,     0,     0,     0,     0,    72,    73,
       0,     0,    53,     0,     0,     7,    51,    59,     0,     0,
     104,    61,     0,     0,    69,    71,    74,    81,     5,     5,
       8,     0,    62,    83,    32,    32,     0,     0,     0,    83,
       0,    33,    75,    76,    70,   199,     9,     0,     0,     0,
      57,    60
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -350,  -350,  -350,   336,    -2,  -255,  -350,  -209,     1,  -140,
     -88,   -18,  -350,  -350,  -350,    86,   -13,  -350,  -350,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,  -350,
    -350,  -350,  -350,  -350,  -350,  -350,   -74,  -350,   -56,  -350,
    -350,  -350,  -350,    96,  -349,   -99,    19,  -350,  -350,   281,
    -151,  -293,  -350,  -350,  -350,  -350,   183,    37,   184,    38,
     182,    39,   187,    34,   201,    52,   202,    56,   -81,   179,
     122,   112,  -350,    44,    -7,     4,  -350,   -22,  -350,  -350,
    -350,  -350,   104,   105,  -350,  -350,   108,   115,  -119,     8,
    -136,  -350,  -350,  -350,   -78,    33,    20,  -319
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    42,   396,    88,   397,   231,   232,   150,   151,
     442,    45,    46,   108,   317,   109,   318,   260,   261,   361,
     362,    47,    48,    49,    50,   319,   419,   364,   431,    51,
      52,    53,    54,    55,    56,   384,   407,   408,   409,   425,
      57,    58,   257,   258,   100,   234,    59,   237,   238,   332,
      60,   239,    61,   240,    62,   241,    63,   242,    64,   243,
      65,   244,    66,   245,    67,   246,    68,   247,    69,    70,
      71,    72,    73,    74,    75,    76,    77,   196,   305,    78,
      79,   163,   164,   165,    80,   152,   153,   341,   154,    84,
     155,   156,    81,    82,   170,    95,   314,   368
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,   105,     3,    44,    98,    43,   200,   201,    91,   269,
      92,   270,   264,    85,   280,    99,   248,   282,   312,   403,
     310,   284,   251,   312,   167,   253,    92,   369,    92,   372,
     263,    43,   101,    92,   168,   103,    92,    92,   381,   382,
     299,   300,    96,    97,   304,   401,   328,   102,   423,    93,
      90,   167,   417,   281,   366,   199,   111,   112,   302,   104,
     166,    92,   307,  -218,    90,    93,    90,   399,   168,    90,
      90,   228,   329,   173,   168,    92,   169,   250,    94,    90,
      90,  -220,    90,    90,   440,   255,    92,   313,   171,  -217,
     447,   424,   313,   256,    94,    83,    94,   290,   291,   292,
     433,    94,    43,   169,    94,    94,   367,   167,   337,   172,
     107,   420,   439,    43,  -227,   235,   266,   178,    89,   179,
      43,   252,   105,    91,   346,    98,   229,    85,  -235,    94,
     235,   265,   106,   388,   110,   115,    99,   113,   114,  -236,
     414,   249,   351,    94,   174,   180,   394,   157,   158,    43,
     159,   160,   272,   101,    94,     8,   103,   262,    96,   169,
      97,   352,   321,    11,    12,    90,   175,    15,   102,    17,
      18,   176,   161,   437,   438,   177,   276,   111,   112,   181,
     278,    83,    28,   322,    86,    90,   168,    90,   162,    30,
      31,    32,   277,    87,    83,  -207,   279,   390,   391,   227,
     392,   168,   350,   230,   434,   259,    37,   168,  -210,   354,
      40,  -224,   301,    41,  -228,    90,   306,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,   380,   193,    89,   194,   195,   168,   330,   335,   248,
     248,   248,   248,   248,   248,   248,   248,   378,   379,  -230,
     248,   248,   353,   106,   315,   110,   187,   188,  -215,   189,
     308,  -202,   190,   309,   187,   188,   402,   189,   182,   183,
     190,  -201,   333,   331,   187,   188,   275,   189,   311,   248,
     190,   191,   187,   188,   339,   340,   273,   274,   334,   316,
     197,   331,   198,   195,   441,   441,   296,   297,   298,   184,
     185,   186,   342,   342,   294,   295,   320,   323,   324,   326,
     325,   327,   256,    43,   161,   412,   359,   357,   349,   358,
     360,   365,   363,   248,   383,   385,   398,   235,   395,   278,
     356,   406,   415,   428,   404,   429,     2,    43,    43,   430,
     386,   387,   355,   444,   435,   445,   446,   443,   338,   235,
     400,   436,   426,   336,   283,   192,   286,   285,   371,   375,
     293,   373,   287,   374,   370,    90,   370,    90,    90,    90,
      90,    90,    90,    90,   393,   370,   370,   288,   376,   289,
     347,   348,   345,   377,   235,   343,     0,   101,     0,     0,
       0,     0,   427,     0,    43,     0,    43,    44,     0,   416,
     405,     0,     0,    43,   370,   410,   421,     0,   411,     0,
       0,     0,     0,     0,   413,     0,    43,     0,     0,   432,
     101,     0,   418,     0,     0,   422,     0,     0,     0,     0,
       0,     0,    43,    43,     0,     0,     0,     0,     0,    43,
       0,     0,   272,     0,   233,     0,    43,    43,   370,   450,
     451,     6,   101,     0,     8,     0,     0,     0,   101,     0,
     448,     0,    11,    12,     0,     0,    15,   449,    17,    18,
       0,    20,     0,    22,     0,     0,     0,     0,    25,    26,
       0,    28,  -163,    86,     0,     0,     0,     0,    30,    31,
      32,     0,    87,     0,     0,     0,     0,  -163,     0,  -163,
       0,     0,    35,    36,     0,    37,     0,    38,    39,    40,
       0,     0,    41,  -191,  -163,  -163,     0,     0,     0,     0,
       0,     0,  -163,  -163,  -163,  -163,     0,     0,  -191,     0,
    -191,     0,  -163,  -163,     0,     0,  -163,  -163,  -163,  -163,
       0,     0,  -163,     0,  -163,  -191,  -191,     0,     0,  -163,
       0,     0,     0,  -191,  -191,  -191,  -191,     0,     0,     0,
       0,     0,     0,  -191,  -191,     0,     0,  -191,  -191,  -191,
    -191,     0,     0,  -191,     0,  -191,     0,     0,     0,     0,
    -191,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,    25,    26,     0,    28,     0,   146,     0,
       0,     0,     0,   147,    31,   148,     0,    33,   149,     0,
       0,    34,     0,     0,     0,     0,     0,    35,    36,     0,
      37,     0,    38,    39,    40,     4,     0,    41,     5,     0,
       6,     7,     0,     8,     9,     0,    10,     0,     0,     0,
       0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,     0,     0,    25,    26,    27,
      28,     0,    29,     0,     0,     0,     0,    30,    31,    32,
       0,    33,     0,     0,     0,    34,     0,     0,     0,     0,
       0,    35,    36,     0,    37,     0,    38,    39,    40,     4,
       0,    41,     5,     0,     6,     7,     0,     8,     9,     0,
      10,     0,     0,     0,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,     0,
       0,    25,    26,     0,    28,     0,    29,     0,     0,     0,
       0,    30,    31,    32,     0,    33,   254,     0,     0,    34,
       0,     0,     0,     0,     0,    35,    36,     0,    37,     0,
      38,    39,    40,     4,     0,    41,     5,     0,     6,     7,
       0,     8,     9,     0,    10,     0,     0,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,     0,     0,    25,    26,     0,    28,     0,
      29,     0,     0,     0,     0,    30,    31,    32,     0,    33,
     271,     0,     0,    34,     0,     0,     0,     0,     0,    35,
      36,     0,    37,     0,    38,    39,    40,     4,     0,    41,
       5,     0,     6,     7,     0,     8,     9,     0,    10,     0,
       0,     0,     0,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,     0,     0,    25,
      26,     0,    28,     0,    29,     0,     0,     0,     0,    30,
      31,    32,     0,    33,     0,     0,     0,    34,     0,     0,
       0,     0,     0,    35,    36,     0,    37,     0,    38,    39,
      40,     6,     0,    41,     8,     0,     0,     0,     0,     0,
       0,     0,    11,    12,     0,     0,    15,     0,    17,    18,
       0,    20,     0,    22,     0,     0,     0,     0,    25,    26,
       0,    28,     0,    86,     0,     0,     0,     0,    30,    31,
      32,     0,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,     0,    37,     0,    38,    39,    40,
       0,     6,    41,   303,     8,     0,     0,     0,     0,     0,
       0,     0,    11,    12,     0,     0,    15,     0,    17,    18,
       0,    20,   236,    22,     0,     0,     0,     0,    25,    26,
       0,    28,     0,    86,     0,     0,     0,     0,    30,    31,
      32,     0,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,     0,    37,     0,    38,    39,    40,
       6,     0,    41,     8,     0,     0,     0,     0,     0,     0,
       0,    11,    12,     0,     0,    15,     0,    17,    18,     0,
      20,     0,    22,     0,     0,     0,     0,    25,    26,     0,
      28,     0,    86,     0,     0,     0,     0,    30,    31,    32,
       0,    87,     0,     0,     0,     0,  -225,     0,     0,     0,
       0,    35,    36,     0,    37,     0,    38,    39,    40,     6,
       0,    41,     8,     0,     0,     0,     0,     0,     0,     0,
      11,    12,     0,     0,    15,     0,    17,    18,     0,    20,
       0,    22,     0,     0,     0,     0,    25,    26,     0,    28,
       0,    86,     0,     0,     0,     0,    30,    31,    32,     0,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,     0,    37,     0,    38,    39,    40,   389,     6,
      41,     0,     8,     0,     0,     0,     0,     0,     0,     0,
      11,    12,     0,     0,    15,     0,    17,    18,     0,    20,
       0,    22,     0,     0,     0,     0,    25,    26,     0,    28,
       0,    86,     0,     0,     0,     0,    30,    31,    32,     0,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,     0,    37,     0,    38,    39,    40,     0,     0,
      41,   202,   117,   118,   203,   120,   204,   205,   123,   206,
     207,   126,   208,   128,   129,   130,   131,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,   224,     0,   225,     0,     0,   226,   202,
     117,   118,   203,   120,   204,   205,   123,   206,   207,   126,
     208,   128,   129,   130,   131,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,   224,     0,   225,     0,     0,   344,   202,   117,   118,
     203,   120,   204,   205,   123,   206,   207,   126,   208,   267,
     129,   268,   131,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,   224,
       0,   225,   202,   117,   118,   203,   120,   204,   205,   123,
     206,   207,   126,   208,   267,   129,   268,   131,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223
};

static const yytype_int16 yycheck[] =
{
       2,    19,     0,     2,    11,     7,    84,    85,     7,   128,
       1,   130,   111,     5,   165,    11,    97,   168,     1,   368,
     229,   172,   100,     1,     1,   103,     1,   320,     1,   322,
     108,    33,    13,     1,    51,    16,     1,     1,   331,   332,
     191,   192,     9,    10,   195,   364,    18,    14,     7,    40,
       6,     1,   401,    70,     1,    77,    23,    24,   194,    49,
      41,     1,   198,    54,    20,    40,    22,   360,    51,    25,
      26,    39,    44,    33,    51,     1,    53,    99,    69,    35,
      36,    54,    38,    39,   433,     5,     1,    70,    34,    54,
     439,    50,    70,    13,    69,    40,    69,   178,   179,   180,
     419,    69,   104,    53,    69,    69,    53,     1,   259,    55,
      40,   404,   431,   115,    54,    96,   115,    16,     6,    18,
     122,   102,   140,   122,   275,   132,    93,   119,    54,    69,
     111,   112,    20,   342,    22,    54,   132,    25,    26,    54,
     395,    97,    51,    69,    56,    44,   355,    35,    36,   151,
      38,    39,   151,   134,    69,    11,   137,    51,   125,    53,
     127,    70,    34,    19,    20,   121,    57,    23,   135,    25,
      26,    58,    51,   428,   429,    42,    51,   144,   145,    43,
      51,    40,    38,    55,    40,   141,    51,   143,    67,    45,
      46,    47,    67,    49,    40,    54,    67,   348,   349,    31,
     351,    51,    67,    40,    54,    52,    62,    51,    54,   308,
      66,    54,   193,    69,    54,   171,   197,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   330,    66,   121,    68,    69,    51,    16,   256,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    54,
     331,   332,    67,   141,   234,   143,    35,    36,    54,    38,
     227,    54,    41,    40,    35,    36,   365,    38,    59,    60,
      41,    54,   252,    52,    35,    36,    54,    38,    51,   360,
      41,    52,    35,    36,   264,   265,    50,    51,   255,    40,
      66,    52,    68,    69,   434,   435,   184,   185,   186,    61,
      62,    63,   269,   270,   182,   183,    51,    33,    56,    58,
      57,    42,    13,   315,    51,   393,   315,    40,    54,    49,
      52,    16,    51,   404,    49,    40,    10,   308,    49,    51,
     310,     4,    50,    49,    54,    49,     0,   339,   340,    50,
     339,   340,   309,    50,    54,    50,    50,   435,   262,   330,
     363,   425,   408,   257,   171,    74,   174,   173,   321,   325,
     181,   323,   175,   324,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   354,   331,   332,   176,   326,   177,
     276,   276,   274,   327,   365,   270,    -1,   368,    -1,    -1,
      -1,    -1,   410,    -1,   396,    -1,   398,   396,    -1,   398,
     380,    -1,    -1,   405,   360,   385,   405,    -1,   388,    -1,
      -1,    -1,    -1,    -1,   394,    -1,   418,    -1,    -1,   418,
     401,    -1,   402,    -1,    -1,   406,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,    -1,    -1,    -1,    -1,    -1,   441,
      -1,    -1,   441,    -1,     1,    -1,   448,   449,   404,   448,
     449,     8,   433,    -1,    11,    -1,    -1,    -1,   439,    -1,
     440,    -1,    19,    20,    -1,    -1,    23,   447,    25,    26,
      -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,
      -1,    38,     1,    40,    -1,    -1,    -1,    -1,    45,    46,
      47,    -1,    49,    -1,    -1,    -1,    -1,    16,    -1,    18,
      -1,    -1,    59,    60,    -1,    62,    -1,    64,    65,    66,
      -1,    -1,    69,     1,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    42,    43,    44,    -1,    -1,    16,    -1,
      18,    -1,    51,    52,    -1,    -1,    55,    56,    57,    58,
      -1,    -1,    61,    -1,    63,    33,    34,    -1,    -1,    68,
      -1,    -1,    -1,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    52,    -1,    -1,    55,    56,    57,
      58,    -1,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,
      68,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    35,    36,    -1,    38,    -1,    40,    -1,
      -1,    -1,    -1,    45,    46,    47,    -1,    49,    50,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    59,    60,    -1,
      62,    -1,    64,    65,    66,     3,    -1,    69,     6,    -1,
       8,     9,    -1,    11,    12,    -1,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,    47,
      -1,    49,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    59,    60,    -1,    62,    -1,    64,    65,    66,     3,
      -1,    69,     6,    -1,     8,     9,    -1,    11,    12,    -1,
      14,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    35,    36,    -1,    38,    -1,    40,    -1,    -1,    -1,
      -1,    45,    46,    47,    -1,    49,    50,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    59,    60,    -1,    62,    -1,
      64,    65,    66,     3,    -1,    69,     6,    -1,     8,     9,
      -1,    11,    12,    -1,    14,    -1,    -1,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    35,    36,    -1,    38,    -1,
      40,    -1,    -1,    -1,    -1,    45,    46,    47,    -1,    49,
      50,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    59,
      60,    -1,    62,    -1,    64,    65,    66,     3,    -1,    69,
       6,    -1,     8,     9,    -1,    11,    12,    -1,    14,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    35,
      36,    -1,    38,    -1,    40,    -1,    -1,    -1,    -1,    45,
      46,    47,    -1,    49,    -1,    -1,    -1,    53,    -1,    -1,
      -1,    -1,    -1,    59,    60,    -1,    62,    -1,    64,    65,
      66,     8,    -1,    69,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    -1,    23,    -1,    25,    26,
      -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,
      -1,    38,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,
      47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    60,    -1,    62,    -1,    64,    65,    66,
      -1,     8,    69,    70,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    -1,    23,    -1,    25,    26,
      -1,    28,    29,    30,    -1,    -1,    -1,    -1,    35,    36,
      -1,    38,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,
      47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    60,    -1,    62,    -1,    64,    65,    66,
       8,    -1,    69,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    -1,    23,    -1,    25,    26,    -1,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,    47,
      -1,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    62,    -1,    64,    65,    66,     8,
      -1,    69,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    -1,    23,    -1,    25,    26,    -1,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      -1,    40,    -1,    -1,    -1,    -1,    45,    46,    47,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    60,    -1,    62,    -1,    64,    65,    66,    67,     8,
      69,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    -1,    23,    -1,    25,    26,    -1,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      -1,    40,    -1,    -1,    -1,    -1,    45,    46,    47,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    60,    -1,    62,    -1,    64,    65,    66,    -1,    -1,
      69,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    -1,    45,    -1,    47,    -1,    -1,    50,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    45,    -1,    47,    -1,    -1,    50,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    45,
      -1,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    72,    74,     0,     3,     6,     8,     9,    11,    12,
      14,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    35,    36,    37,    38,    40,
      45,    46,    47,    49,    53,    59,    60,    62,    64,    65,
      66,    69,    73,    75,    79,    82,    83,    92,    93,    94,
      95,   100,   101,   102,   103,   104,   105,   111,   112,   117,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   150,   151,
     155,   163,   164,    40,   160,   160,    40,    49,    75,   142,
     144,    79,     1,    40,    69,   166,   166,   166,   145,   146,
     115,   117,   166,   117,    49,    82,   142,    40,    84,    86,
     142,   166,   166,   142,   142,    54,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    40,    45,    47,    50,
      79,    80,   156,   157,   159,   161,   162,   142,   142,   142,
     142,    51,    67,   152,   153,   154,   117,     1,    51,    53,
     165,    34,    55,    33,    56,    57,    58,    42,    16,    18,
      44,    43,    59,    60,    61,    62,    63,    35,    36,    38,
      41,    52,   120,    66,    68,    69,   148,    66,    68,   148,
     165,   165,     3,     6,     8,     9,    11,    12,    14,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    40,    45,    47,    50,    31,    39,   166,
      40,    77,    78,     1,   116,   117,    29,   118,   119,   122,
     124,   126,   128,   130,   132,   134,   136,   138,   139,   144,
     148,   165,   117,   165,    50,     5,    13,   113,   114,    52,
      88,    89,    51,   165,   116,   117,    79,    15,    17,   159,
     159,    50,    79,    50,    51,    54,    51,    67,    51,    67,
     121,    70,   121,   127,   121,   129,   131,   133,   135,   137,
     139,   139,   139,   140,   141,   141,   142,   142,   142,   121,
     121,   117,   161,    70,   121,   149,   117,   161,   166,    40,
      78,    51,     1,    70,   167,   167,    40,    85,    87,    96,
      51,    34,    55,    33,    56,    57,    58,    42,    18,    44,
      16,    52,   120,   167,   166,    82,   114,   121,    86,   167,
     167,   158,   166,   158,    50,   157,   121,   153,   154,    54,
      67,    51,    70,    67,   116,   166,   167,    40,    49,    79,
      52,    90,    91,    51,    98,    16,     1,    53,   168,   122,
     144,   128,   122,   130,   132,   134,   136,   138,   139,   139,
     116,   122,   122,    49,   106,    40,    79,    79,    78,    67,
     121,   121,   121,   167,    78,    49,    74,    76,    10,   122,
      87,   168,   116,   115,    54,   167,     4,   107,   108,   109,
     167,   167,   165,   167,    76,    50,    79,   115,   167,    97,
     122,    79,   117,     7,    50,   110,   109,    82,    49,    49,
      50,    99,    79,   168,    54,    54,   107,    76,    76,   168,
     115,    80,    81,    81,    50,    50,    50,   115,   167,   167,
      79,    79
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    71,    72,    73,    73,    74,    74,    75,    75,    75,
      76,    77,    77,    78,    78,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      80,    80,    81,    81,    82,    82,    83,    84,    84,    85,
      85,    86,    87,    88,    88,    89,    90,    90,    91,    92,
      93,    94,    94,    95,    95,    96,    97,    95,    98,    99,
      95,    95,    95,   100,   101,   102,   103,   104,   105,   106,
     106,   107,   107,   108,   108,   109,   110,   111,   112,   112,
     112,   113,   114,   115,   115,   116,   116,   117,   117,   118,
     118,   119,   119,   120,   120,   121,   121,   121,   122,   122,
     122,   123,   123,   124,   124,   125,   125,   126,   126,   127,
     127,   128,   128,   129,   129,   130,   130,   131,   131,   132,
     132,   133,   133,   134,   134,   135,   135,   136,   136,   137,
     137,   137,   137,   138,   138,   138,   139,   139,   140,   140,
     140,   141,   141,   141,   141,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   143,   143,   143,   144,   144,
     145,   145,   146,   146,   146,   146,   146,   147,   147,   147,
     147,   148,   148,   149,   149,   150,   150,   150,   150,   150,
     150,   151,   151,   151,   151,   152,   152,   153,   153,   154,
     154,   155,   155,   155,   156,   156,   157,   157,   157,   158,
     159,   159,   159,   160,   160,   161,   161,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   163,   163,   163,
     163,   163,   163,   164,   164,   164,   165,   165,   166,   166,
     167,   167,   168,   168
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     0,     0,     2,     7,     8,    10,
       1,     1,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     1,     3,     2,     3,     1,     3,     1,
       3,     2,     2,     0,     1,     2,     0,     1,     2,     1,
       2,     7,     5,     7,     5,     0,     0,    11,     0,     0,
      12,     7,     8,     3,     3,     3,     5,     3,     5,     3,
       5,     0,     1,     1,     2,     4,     3,     3,     3,     3,
       4,     5,     2,     0,     1,     1,     1,     1,     3,     0,
       1,     1,     3,     1,     1,     1,     3,     3,     1,     3,
       3,     1,     5,     1,     5,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     2,     1,     1,     4,     3,     3,     2,     2,     4,
       3,     2,     3,     1,     3,     1,     1,     1,     1,     1,
       3,     2,     3,     3,     5,     2,     4,     1,     2,     0,
       1,     2,     3,     4,     1,     3,     3,     3,     3,     6,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, ctx, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, parser_ctx_t *ctx)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, parser_ctx_t *ctx)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp, ctx);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, parser_ctx_t *ctx)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 255 "dlls/jscript/parser.y"
                                    { ctx->source = (yyvsp[-1].source_elements); }
#line 2156 "dlls/jscript/parser.tab.c"
    break;

  case 5:
#line 263 "dlls/jscript/parser.y"
                                { (yyval.source_elements) = new_source_elements(ctx); }
#line 2162 "dlls/jscript/parser.tab.c"
    break;

  case 6:
#line 265 "dlls/jscript/parser.y"
                                { (yyval.source_elements) = source_elements_add_statement((yyvsp[-1].source_elements), (yyvsp[0].statement)); }
#line 2168 "dlls/jscript/parser.tab.c"
    break;

  case 7:
#line 270 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_function_expression(ctx, NULL, (yyvsp[-4].parameter_list), (yyvsp[-1].source_elements), NULL, ctx->begin + (yylsp[-6]), (yylsp[0]) - (yylsp[-6]) + 1); }
#line 2174 "dlls/jscript/parser.tab.c"
    break;

  case 8:
#line 272 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_function_expression(ctx, (yyvsp[-6].identifier), (yyvsp[-4].parameter_list), (yyvsp[-1].source_elements), NULL, ctx->begin + (yylsp[-7]), (yylsp[0]) - (yylsp[-7]) + 1); }
#line 2180 "dlls/jscript/parser.tab.c"
    break;

  case 9:
#line 274 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_function_expression(ctx, (yyvsp[-6].identifier), (yyvsp[-4].parameter_list), (yyvsp[-1].source_elements), (yyvsp[-8].identifier), ctx->begin + (yylsp[-9]), (yylsp[0]) - (yylsp[-9]) + 1); }
#line 2186 "dlls/jscript/parser.tab.c"
    break;

  case 10:
#line 278 "dlls/jscript/parser.y"
                                { (yyval.source_elements) = (yyvsp[0].source_elements); }
#line 2192 "dlls/jscript/parser.tab.c"
    break;

  case 11:
#line 282 "dlls/jscript/parser.y"
                                { (yyval.parameter_list) = new_parameter_list(ctx, (yyvsp[0].identifier)); }
#line 2198 "dlls/jscript/parser.tab.c"
    break;

  case 12:
#line 284 "dlls/jscript/parser.y"
                                { (yyval.parameter_list) = parameter_list_add(ctx, (yyvsp[-2].parameter_list), (yyvsp[0].identifier)); }
#line 2204 "dlls/jscript/parser.tab.c"
    break;

  case 13:
#line 288 "dlls/jscript/parser.y"
                                { (yyval.parameter_list) = NULL; }
#line 2210 "dlls/jscript/parser.tab.c"
    break;

  case 14:
#line 289 "dlls/jscript/parser.y"
                                { (yyval.parameter_list) = (yyvsp[0].parameter_list); }
#line 2216 "dlls/jscript/parser.tab.c"
    break;

  case 15:
#line 293 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2222 "dlls/jscript/parser.tab.c"
    break;

  case 16:
#line 294 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2228 "dlls/jscript/parser.tab.c"
    break;

  case 17:
#line 295 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2234 "dlls/jscript/parser.tab.c"
    break;

  case 18:
#line 296 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_expression_statement(ctx, (yyloc), (yyvsp[0].expr)); }
#line 2240 "dlls/jscript/parser.tab.c"
    break;

  case 19:
#line 297 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2246 "dlls/jscript/parser.tab.c"
    break;

  case 20:
#line 298 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2252 "dlls/jscript/parser.tab.c"
    break;

  case 21:
#line 299 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2258 "dlls/jscript/parser.tab.c"
    break;

  case 22:
#line 300 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2264 "dlls/jscript/parser.tab.c"
    break;

  case 23:
#line 301 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2270 "dlls/jscript/parser.tab.c"
    break;

  case 24:
#line 302 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2276 "dlls/jscript/parser.tab.c"
    break;

  case 25:
#line 303 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2282 "dlls/jscript/parser.tab.c"
    break;

  case 26:
#line 304 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2288 "dlls/jscript/parser.tab.c"
    break;

  case 27:
#line 305 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2294 "dlls/jscript/parser.tab.c"
    break;

  case 28:
#line 306 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2300 "dlls/jscript/parser.tab.c"
    break;

  case 29:
#line 307 "dlls/jscript/parser.y"
                                { (yyval.statement) = (yyvsp[0].statement); }
#line 2306 "dlls/jscript/parser.tab.c"
    break;

  case 30:
#line 311 "dlls/jscript/parser.y"
                                { (yyval.statement_list) = new_statement_list(ctx, (yyvsp[0].statement)); }
#line 2312 "dlls/jscript/parser.tab.c"
    break;

  case 31:
#line 313 "dlls/jscript/parser.y"
                                { (yyval.statement_list) = statement_list_add((yyvsp[-1].statement_list), (yyvsp[0].statement)); }
#line 2318 "dlls/jscript/parser.tab.c"
    break;

  case 32:
#line 317 "dlls/jscript/parser.y"
                                { (yyval.statement_list) = NULL; }
#line 2324 "dlls/jscript/parser.tab.c"
    break;

  case 33:
#line 318 "dlls/jscript/parser.y"
                                { (yyval.statement_list) = (yyvsp[0].statement_list); }
#line 2330 "dlls/jscript/parser.tab.c"
    break;

  case 34:
#line 322 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_block_statement(ctx, (yylsp[-1]), (yyvsp[-1].statement_list)); }
#line 2336 "dlls/jscript/parser.tab.c"
    break;

  case 35:
#line 323 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_block_statement(ctx, (yyloc), NULL); }
#line 2342 "dlls/jscript/parser.tab.c"
    break;

  case 36:
#line 328 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_var_statement(ctx, (yyloc), (yyvsp[-1].variable_list)); }
#line 2348 "dlls/jscript/parser.tab.c"
    break;

  case 37:
#line 332 "dlls/jscript/parser.y"
                                { (yyval.variable_list) = new_variable_list(ctx, (yyvsp[0].variable_declaration)); }
#line 2354 "dlls/jscript/parser.tab.c"
    break;

  case 38:
#line 334 "dlls/jscript/parser.y"
                                { (yyval.variable_list) = variable_list_add(ctx, (yyvsp[-2].variable_list), (yyvsp[0].variable_declaration)); }
#line 2360 "dlls/jscript/parser.tab.c"
    break;

  case 39:
#line 339 "dlls/jscript/parser.y"
                                { (yyval.variable_list) = new_variable_list(ctx, (yyvsp[0].variable_declaration)); }
#line 2366 "dlls/jscript/parser.tab.c"
    break;

  case 40:
#line 341 "dlls/jscript/parser.y"
                                { (yyval.variable_list) = variable_list_add(ctx, (yyvsp[-2].variable_list), (yyvsp[0].variable_declaration)); }
#line 2372 "dlls/jscript/parser.tab.c"
    break;

  case 41:
#line 346 "dlls/jscript/parser.y"
                                { (yyval.variable_declaration) = new_variable_declaration(ctx, (yyvsp[-1].identifier), (yyvsp[0].expr)); }
#line 2378 "dlls/jscript/parser.tab.c"
    break;

  case 42:
#line 351 "dlls/jscript/parser.y"
                                { (yyval.variable_declaration) = new_variable_declaration(ctx, (yyvsp[-1].identifier), (yyvsp[0].expr)); }
#line 2384 "dlls/jscript/parser.tab.c"
    break;

  case 43:
#line 355 "dlls/jscript/parser.y"
                                { (yyval.expr) = NULL; }
#line 2390 "dlls/jscript/parser.tab.c"
    break;

  case 44:
#line 356 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2396 "dlls/jscript/parser.tab.c"
    break;

  case 45:
#line 361 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2402 "dlls/jscript/parser.tab.c"
    break;

  case 46:
#line 365 "dlls/jscript/parser.y"
                                { (yyval.expr) = NULL; }
#line 2408 "dlls/jscript/parser.tab.c"
    break;

  case 47:
#line 366 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2414 "dlls/jscript/parser.tab.c"
    break;

  case 48:
#line 371 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2420 "dlls/jscript/parser.tab.c"
    break;

  case 49:
#line 375 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_statement(ctx, STAT_EMPTY, 0, (yyloc)); }
#line 2426 "dlls/jscript/parser.tab.c"
    break;

  case 50:
#line 380 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_expression_statement(ctx, (yyloc),  (yyvsp[-1].expr)); }
#line 2432 "dlls/jscript/parser.tab.c"
    break;

  case 51:
#line 385 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_if_statement(ctx, (yyloc), (yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement)); }
#line 2438 "dlls/jscript/parser.tab.c"
    break;

  case 52:
#line 387 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_if_statement(ctx, (yyloc), (yyvsp[-2].expr), (yyvsp[0].statement), NULL); }
#line 2444 "dlls/jscript/parser.tab.c"
    break;

  case 53:
#line 392 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_while_statement(ctx, (yylsp[-4]), TRUE, (yyvsp[-2].expr), (yyvsp[-5].statement)); }
#line 2450 "dlls/jscript/parser.tab.c"
    break;

  case 54:
#line 394 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_while_statement(ctx, (yyloc), FALSE, (yyvsp[-2].expr), (yyvsp[0].statement)); }
#line 2456 "dlls/jscript/parser.tab.c"
    break;

  case 55:
#line 396 "dlls/jscript/parser.y"
                                { if(!explicit_error(ctx, (yyvsp[0].expr), ';')) YYABORT; }
#line 2462 "dlls/jscript/parser.tab.c"
    break;

  case 56:
#line 398 "dlls/jscript/parser.y"
                                { if(!explicit_error(ctx, (yyvsp[0].expr), ';')) YYABORT; }
#line 2468 "dlls/jscript/parser.tab.c"
    break;

  case 57:
#line 400 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_for_statement(ctx, (yylsp[-8]), NULL, (yyvsp[-8].expr), (yyvsp[-5].expr), (yylsp[-5]), (yyvsp[-2].expr), (yylsp[-2]), (yyvsp[0].statement)); }
#line 2474 "dlls/jscript/parser.tab.c"
    break;

  case 58:
#line 402 "dlls/jscript/parser.y"
                                { if(!explicit_error(ctx, (yyvsp[0].variable_list), ';')) YYABORT; }
#line 2480 "dlls/jscript/parser.tab.c"
    break;

  case 59:
#line 404 "dlls/jscript/parser.y"
                                { if(!explicit_error(ctx, (yyvsp[0].expr), ';')) YYABORT; }
#line 2486 "dlls/jscript/parser.tab.c"
    break;

  case 60:
#line 406 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_for_statement(ctx, (yylsp[-9]), (yyvsp[-8].variable_list), NULL, (yyvsp[-5].expr), (yylsp[-5]), (yyvsp[-2].expr), (yylsp[-2]), (yyvsp[0].statement)); }
#line 2492 "dlls/jscript/parser.tab.c"
    break;

  case 61:
#line 408 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_forin_statement(ctx, (yyloc), NULL, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].statement)); }
#line 2498 "dlls/jscript/parser.tab.c"
    break;

  case 62:
#line 410 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_forin_statement(ctx, (yyloc),  (yyvsp[-4].variable_declaration), NULL, (yyvsp[-2].expr), (yyvsp[0].statement)); }
#line 2504 "dlls/jscript/parser.tab.c"
    break;

  case 63:
#line 415 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_continue_statement(ctx, (yyloc), (yyvsp[-1].identifier)); }
#line 2510 "dlls/jscript/parser.tab.c"
    break;

  case 64:
#line 420 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_break_statement(ctx, (yyloc), (yyvsp[-1].identifier)); }
#line 2516 "dlls/jscript/parser.tab.c"
    break;

  case 65:
#line 425 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_return_statement(ctx, (yyloc), (yyvsp[-1].expr)); }
#line 2522 "dlls/jscript/parser.tab.c"
    break;

  case 66:
#line 430 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_with_statement(ctx, (yyloc), (yyvsp[-2].expr), (yyvsp[0].statement)); }
#line 2528 "dlls/jscript/parser.tab.c"
    break;

  case 67:
#line 435 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_labelled_statement(ctx, (yyloc), (yyvsp[-2].identifier), (yyvsp[0].statement)); }
#line 2534 "dlls/jscript/parser.tab.c"
    break;

  case 68:
#line 440 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_switch_statement(ctx, (yyloc), (yyvsp[-2].expr), (yyvsp[0].case_clausule)); }
#line 2540 "dlls/jscript/parser.tab.c"
    break;

  case 69:
#line 445 "dlls/jscript/parser.y"
                                 { (yyval.case_clausule) = new_case_block(ctx, (yyvsp[-1].case_list), NULL, NULL); }
#line 2546 "dlls/jscript/parser.tab.c"
    break;

  case 70:
#line 447 "dlls/jscript/parser.y"
                                 { (yyval.case_clausule) = new_case_block(ctx, (yyvsp[-3].case_list), (yyvsp[-2].case_clausule), (yyvsp[-1].case_list)); }
#line 2552 "dlls/jscript/parser.tab.c"
    break;

  case 71:
#line 451 "dlls/jscript/parser.y"
                                 { (yyval.case_list) = NULL; }
#line 2558 "dlls/jscript/parser.tab.c"
    break;

  case 72:
#line 452 "dlls/jscript/parser.y"
                                 { (yyval.case_list) = (yyvsp[0].case_list); }
#line 2564 "dlls/jscript/parser.tab.c"
    break;

  case 73:
#line 456 "dlls/jscript/parser.y"
                                 { (yyval.case_list) = new_case_list(ctx, (yyvsp[0].case_clausule)); }
#line 2570 "dlls/jscript/parser.tab.c"
    break;

  case 74:
#line 458 "dlls/jscript/parser.y"
                                 { (yyval.case_list) = case_list_add(ctx, (yyvsp[-1].case_list), (yyvsp[0].case_clausule)); }
#line 2576 "dlls/jscript/parser.tab.c"
    break;

  case 75:
#line 463 "dlls/jscript/parser.y"
                                 { (yyval.case_clausule) = new_case_clausule(ctx, (yyloc), (yyvsp[-2].expr), (yyvsp[0].statement_list)); }
#line 2582 "dlls/jscript/parser.tab.c"
    break;

  case 76:
#line 468 "dlls/jscript/parser.y"
                                 { (yyval.case_clausule) = new_case_clausule(ctx, (yyloc), NULL, (yyvsp[0].statement_list)); }
#line 2588 "dlls/jscript/parser.tab.c"
    break;

  case 77:
#line 473 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_throw_statement(ctx, (yyloc), (yyvsp[-1].expr)); }
#line 2594 "dlls/jscript/parser.tab.c"
    break;

  case 78:
#line 477 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_try_statement(ctx, (yyvsp[-1].statement), (yyvsp[0].catch_block), NULL, 0); }
#line 2600 "dlls/jscript/parser.tab.c"
    break;

  case 79:
#line 478 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_try_statement(ctx, (yyvsp[-1].statement), NULL, (yyvsp[0].statement), (yylsp[0])); }
#line 2606 "dlls/jscript/parser.tab.c"
    break;

  case 80:
#line 480 "dlls/jscript/parser.y"
                                { (yyval.statement) = new_try_statement(ctx, (yyvsp[-2].statement), (yyvsp[-1].catch_block), (yyvsp[0].statement), (yylsp[0])); }
#line 2612 "dlls/jscript/parser.tab.c"
    break;

  case 81:
#line 485 "dlls/jscript/parser.y"
                                { (yyval.catch_block) = new_catch_block(ctx, (yyvsp[-2].identifier), (yyvsp[0].statement)); }
#line 2618 "dlls/jscript/parser.tab.c"
    break;

  case 82:
#line 489 "dlls/jscript/parser.y"
                                { (yyloc) = (yylsp[0]); (yyval.statement) = (yyvsp[0].statement); }
#line 2624 "dlls/jscript/parser.tab.c"
    break;

  case 83:
#line 493 "dlls/jscript/parser.y"
                                { (yyval.expr) = NULL; }
#line 2630 "dlls/jscript/parser.tab.c"
    break;

  case 84:
#line 494 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2636 "dlls/jscript/parser.tab.c"
    break;

  case 85:
#line 497 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2642 "dlls/jscript/parser.tab.c"
    break;

  case 86:
#line 498 "dlls/jscript/parser.y"
                                { set_error(ctx, (yyloc), JS_E_SYNTAX); YYABORT; }
#line 2648 "dlls/jscript/parser.tab.c"
    break;

  case 87:
#line 502 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2654 "dlls/jscript/parser.tab.c"
    break;

  case 88:
#line 504 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2660 "dlls/jscript/parser.tab.c"
    break;

  case 89:
#line 508 "dlls/jscript/parser.y"
                                { (yyval.expr) = NULL; }
#line 2666 "dlls/jscript/parser.tab.c"
    break;

  case 90:
#line 509 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2672 "dlls/jscript/parser.tab.c"
    break;

  case 91:
#line 514 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2678 "dlls/jscript/parser.tab.c"
    break;

  case 92:
#line 516 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2684 "dlls/jscript/parser.tab.c"
    break;

  case 93:
#line 519 "dlls/jscript/parser.y"
                                { (yyval.ival) = (yyvsp[0].ival); }
#line 2690 "dlls/jscript/parser.tab.c"
    break;

  case 94:
#line 520 "dlls/jscript/parser.y"
                                { (yyval.ival) = EXPR_ASSIGNDIV; }
#line 2696 "dlls/jscript/parser.tab.c"
    break;

  case 95:
#line 524 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2702 "dlls/jscript/parser.tab.c"
    break;

  case 96:
#line 526 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_ASSIGN, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2708 "dlls/jscript/parser.tab.c"
    break;

  case 97:
#line 528 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2714 "dlls/jscript/parser.tab.c"
    break;

  case 98:
#line 533 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2720 "dlls/jscript/parser.tab.c"
    break;

  case 99:
#line 535 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_ASSIGN, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2726 "dlls/jscript/parser.tab.c"
    break;

  case 100:
#line 537 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2732 "dlls/jscript/parser.tab.c"
    break;

  case 101:
#line 541 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2738 "dlls/jscript/parser.tab.c"
    break;

  case 102:
#line 543 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_conditional_expression(ctx, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2744 "dlls/jscript/parser.tab.c"
    break;

  case 103:
#line 548 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2750 "dlls/jscript/parser.tab.c"
    break;

  case 104:
#line 550 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_conditional_expression(ctx, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2756 "dlls/jscript/parser.tab.c"
    break;

  case 105:
#line 554 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2762 "dlls/jscript/parser.tab.c"
    break;

  case 106:
#line 556 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2768 "dlls/jscript/parser.tab.c"
    break;

  case 107:
#line 561 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2774 "dlls/jscript/parser.tab.c"
    break;

  case 108:
#line 563 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2780 "dlls/jscript/parser.tab.c"
    break;

  case 109:
#line 567 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2786 "dlls/jscript/parser.tab.c"
    break;

  case 110:
#line 569 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2792 "dlls/jscript/parser.tab.c"
    break;

  case 111:
#line 574 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2798 "dlls/jscript/parser.tab.c"
    break;

  case 112:
#line 576 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2804 "dlls/jscript/parser.tab.c"
    break;

  case 113:
#line 580 "dlls/jscript/parser.y"
                                 { (yyval.expr) = (yyvsp[0].expr); }
#line 2810 "dlls/jscript/parser.tab.c"
    break;

  case 114:
#line 582 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2816 "dlls/jscript/parser.tab.c"
    break;

  case 115:
#line 587 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2822 "dlls/jscript/parser.tab.c"
    break;

  case 116:
#line 589 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2828 "dlls/jscript/parser.tab.c"
    break;

  case 117:
#line 593 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2834 "dlls/jscript/parser.tab.c"
    break;

  case 118:
#line 595 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BXOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2840 "dlls/jscript/parser.tab.c"
    break;

  case 119:
#line 600 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2846 "dlls/jscript/parser.tab.c"
    break;

  case 120:
#line 602 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BXOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2852 "dlls/jscript/parser.tab.c"
    break;

  case 121:
#line 606 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2858 "dlls/jscript/parser.tab.c"
    break;

  case 122:
#line 608 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2864 "dlls/jscript/parser.tab.c"
    break;

  case 123:
#line 613 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2870 "dlls/jscript/parser.tab.c"
    break;

  case 124:
#line 615 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_BAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2876 "dlls/jscript/parser.tab.c"
    break;

  case 125:
#line 619 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2882 "dlls/jscript/parser.tab.c"
    break;

  case 126:
#line 621 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2888 "dlls/jscript/parser.tab.c"
    break;

  case 127:
#line 625 "dlls/jscript/parser.y"
                                    { (yyval.expr) = (yyvsp[0].expr); }
#line 2894 "dlls/jscript/parser.tab.c"
    break;

  case 128:
#line 627 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2900 "dlls/jscript/parser.tab.c"
    break;

  case 129:
#line 631 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2906 "dlls/jscript/parser.tab.c"
    break;

  case 130:
#line 633 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2912 "dlls/jscript/parser.tab.c"
    break;

  case 131:
#line 635 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_INSTANCEOF, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2918 "dlls/jscript/parser.tab.c"
    break;

  case 132:
#line 637 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_IN, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2924 "dlls/jscript/parser.tab.c"
    break;

  case 133:
#line 641 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2930 "dlls/jscript/parser.tab.c"
    break;

  case 134:
#line 643 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2936 "dlls/jscript/parser.tab.c"
    break;

  case 135:
#line 645 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_INSTANCEOF, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2942 "dlls/jscript/parser.tab.c"
    break;

  case 136:
#line 649 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2948 "dlls/jscript/parser.tab.c"
    break;

  case 137:
#line 651 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, (yyvsp[-1].ival), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2954 "dlls/jscript/parser.tab.c"
    break;

  case 138:
#line 656 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2960 "dlls/jscript/parser.tab.c"
    break;

  case 139:
#line 658 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2966 "dlls/jscript/parser.tab.c"
    break;

  case 140:
#line 660 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2972 "dlls/jscript/parser.tab.c"
    break;

  case 141:
#line 664 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 2978 "dlls/jscript/parser.tab.c"
    break;

  case 142:
#line 666 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2984 "dlls/jscript/parser.tab.c"
    break;

  case 143:
#line 668 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2990 "dlls/jscript/parser.tab.c"
    break;

  case 144:
#line 670 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 2996 "dlls/jscript/parser.tab.c"
    break;

  case 145:
#line 674 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3002 "dlls/jscript/parser.tab.c"
    break;

  case 146:
#line 676 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_DELETE, (yyvsp[0].expr)); }
#line 3008 "dlls/jscript/parser.tab.c"
    break;

  case 147:
#line 677 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_VOID, (yyvsp[0].expr)); }
#line 3014 "dlls/jscript/parser.tab.c"
    break;

  case 148:
#line 679 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_TYPEOF, (yyvsp[0].expr)); }
#line 3020 "dlls/jscript/parser.tab.c"
    break;

  case 149:
#line 680 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_PREINC, (yyvsp[0].expr)); }
#line 3026 "dlls/jscript/parser.tab.c"
    break;

  case 150:
#line 681 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_PREDEC, (yyvsp[0].expr)); }
#line 3032 "dlls/jscript/parser.tab.c"
    break;

  case 151:
#line 682 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_PLUS, (yyvsp[0].expr)); }
#line 3038 "dlls/jscript/parser.tab.c"
    break;

  case 152:
#line 683 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_MINUS, (yyvsp[0].expr)); }
#line 3044 "dlls/jscript/parser.tab.c"
    break;

  case 153:
#line 684 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_BITNEG, (yyvsp[0].expr)); }
#line 3050 "dlls/jscript/parser.tab.c"
    break;

  case 154:
#line 685 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_LOGNEG, (yyvsp[0].expr)); }
#line 3056 "dlls/jscript/parser.tab.c"
    break;

  case 155:
#line 690 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3062 "dlls/jscript/parser.tab.c"
    break;

  case 156:
#line 692 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_POSTINC, (yyvsp[-1].expr)); }
#line 3068 "dlls/jscript/parser.tab.c"
    break;

  case 157:
#line 694 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_unary_expression(ctx, EXPR_POSTDEC, (yyvsp[-1].expr)); }
#line 3074 "dlls/jscript/parser.tab.c"
    break;

  case 158:
#line 699 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3080 "dlls/jscript/parser.tab.c"
    break;

  case 159:
#line 700 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3086 "dlls/jscript/parser.tab.c"
    break;

  case 160:
#line 704 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3092 "dlls/jscript/parser.tab.c"
    break;

  case 161:
#line 705 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_new_expression(ctx, (yyvsp[0].expr), NULL); }
#line 3098 "dlls/jscript/parser.tab.c"
    break;

  case 162:
#line 709 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3104 "dlls/jscript/parser.tab.c"
    break;

  case 163:
#line 710 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3110 "dlls/jscript/parser.tab.c"
    break;

  case 164:
#line 712 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_ARRAY, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 3116 "dlls/jscript/parser.tab.c"
    break;

  case 165:
#line 714 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_member_expression(ctx, (yyvsp[-2].expr), (yyvsp[0].identifier)); }
#line 3122 "dlls/jscript/parser.tab.c"
    break;

  case 166:
#line 716 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_new_expression(ctx, (yyvsp[-1].expr), (yyvsp[0].argument_list)); }
#line 3128 "dlls/jscript/parser.tab.c"
    break;

  case 167:
#line 721 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_call_expression(ctx, (yyvsp[-1].expr), (yyvsp[0].argument_list)); }
#line 3134 "dlls/jscript/parser.tab.c"
    break;

  case 168:
#line 723 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_call_expression(ctx, (yyvsp[-1].expr), (yyvsp[0].argument_list)); }
#line 3140 "dlls/jscript/parser.tab.c"
    break;

  case 169:
#line 725 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_binary_expression(ctx, EXPR_ARRAY, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 3146 "dlls/jscript/parser.tab.c"
    break;

  case 170:
#line 727 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_member_expression(ctx, (yyvsp[-2].expr), (yyvsp[0].identifier)); }
#line 3152 "dlls/jscript/parser.tab.c"
    break;

  case 171:
#line 731 "dlls/jscript/parser.y"
                                { (yyval.argument_list) = NULL; }
#line 3158 "dlls/jscript/parser.tab.c"
    break;

  case 172:
#line 732 "dlls/jscript/parser.y"
                                { (yyval.argument_list) = (yyvsp[-1].argument_list); }
#line 3164 "dlls/jscript/parser.tab.c"
    break;

  case 173:
#line 736 "dlls/jscript/parser.y"
                                { (yyval.argument_list) = new_argument_list(ctx, (yyvsp[0].expr)); }
#line 3170 "dlls/jscript/parser.tab.c"
    break;

  case 174:
#line 738 "dlls/jscript/parser.y"
                                { (yyval.argument_list) = argument_list_add(ctx, (yyvsp[-2].argument_list), (yyvsp[0].expr)); }
#line 3176 "dlls/jscript/parser.tab.c"
    break;

  case 175:
#line 742 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_expression(ctx, EXPR_THIS, 0); }
#line 3182 "dlls/jscript/parser.tab.c"
    break;

  case 176:
#line 743 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_identifier_expression(ctx, (yyvsp[0].identifier)); }
#line 3188 "dlls/jscript/parser.tab.c"
    break;

  case 177:
#line 744 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_literal_expression(ctx, (yyvsp[0].literal)); }
#line 3194 "dlls/jscript/parser.tab.c"
    break;

  case 178:
#line 745 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3200 "dlls/jscript/parser.tab.c"
    break;

  case 179:
#line 746 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[0].expr); }
#line 3206 "dlls/jscript/parser.tab.c"
    break;

  case 180:
#line 747 "dlls/jscript/parser.y"
                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 3212 "dlls/jscript/parser.tab.c"
    break;

  case 181:
#line 751 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_array_literal_expression(ctx, NULL, 0); }
#line 3218 "dlls/jscript/parser.tab.c"
    break;

  case 182:
#line 752 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_array_literal_expression(ctx, NULL, (yyvsp[-1].ival)+1); }
#line 3224 "dlls/jscript/parser.tab.c"
    break;

  case 183:
#line 753 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_array_literal_expression(ctx, (yyvsp[-1].element_list), 0); }
#line 3230 "dlls/jscript/parser.tab.c"
    break;

  case 184:
#line 755 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_array_literal_expression(ctx, (yyvsp[-3].element_list), (yyvsp[-1].ival)+1); }
#line 3236 "dlls/jscript/parser.tab.c"
    break;

  case 185:
#line 760 "dlls/jscript/parser.y"
                                { (yyval.element_list) = new_element_list(ctx, (yyvsp[-1].ival), (yyvsp[0].expr)); }
#line 3242 "dlls/jscript/parser.tab.c"
    break;

  case 186:
#line 762 "dlls/jscript/parser.y"
                                { (yyval.element_list) = element_list_add(ctx, (yyvsp[-3].element_list), (yyvsp[-1].ival), (yyvsp[0].expr)); }
#line 3248 "dlls/jscript/parser.tab.c"
    break;

  case 187:
#line 766 "dlls/jscript/parser.y"
                                { (yyval.ival) = 1; }
#line 3254 "dlls/jscript/parser.tab.c"
    break;

  case 188:
#line 767 "dlls/jscript/parser.y"
                                { (yyval.ival) = (yyvsp[-1].ival) + 1; }
#line 3260 "dlls/jscript/parser.tab.c"
    break;

  case 189:
#line 771 "dlls/jscript/parser.y"
                                { (yyval.ival) = 0; }
#line 3266 "dlls/jscript/parser.tab.c"
    break;

  case 190:
#line 772 "dlls/jscript/parser.y"
                                { (yyval.ival) = (yyvsp[0].ival); }
#line 3272 "dlls/jscript/parser.tab.c"
    break;

  case 191:
#line 776 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_prop_and_value_expression(ctx, NULL); }
#line 3278 "dlls/jscript/parser.tab.c"
    break;

  case 192:
#line 778 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_prop_and_value_expression(ctx, (yyvsp[-1].property_list)); }
#line 3284 "dlls/jscript/parser.tab.c"
    break;

  case 193:
#line 780 "dlls/jscript/parser.y"
        {
            if(ctx->script->version < 2) {
                WARN("Trailing comma in object literal is illegal in legacy mode.\n");
                set_error(ctx, (yylsp[-1]), JS_E_SYNTAX);
                YYABORT;
            }
            (yyval.expr) = new_prop_and_value_expression(ctx, (yyvsp[-2].property_list));
        }
#line 3297 "dlls/jscript/parser.tab.c"
    break;

  case 194:
#line 791 "dlls/jscript/parser.y"
                                { (yyval.property_list) = new_property_list(ctx, (yyvsp[0].property_definition)); }
#line 3303 "dlls/jscript/parser.tab.c"
    break;

  case 195:
#line 793 "dlls/jscript/parser.y"
                                { (yyval.property_list) = property_list_add(ctx, (yyvsp[-2].property_list), (yyvsp[0].property_definition)); }
#line 3309 "dlls/jscript/parser.tab.c"
    break;

  case 196:
#line 798 "dlls/jscript/parser.y"
                                { (yyval.property_definition) = new_property_definition(ctx, PROPERTY_DEFINITION_VALUE, (yyvsp[-2].literal), (yyvsp[0].expr)); }
#line 3315 "dlls/jscript/parser.tab.c"
    break;

  case 197:
#line 800 "dlls/jscript/parser.y"
                                { (yyval.property_definition) = new_property_definition(ctx, PROPERTY_DEFINITION_GETTER, (yyvsp[-1].literal), (yyvsp[0].expr)); }
#line 3321 "dlls/jscript/parser.tab.c"
    break;

  case 198:
#line 802 "dlls/jscript/parser.y"
                                { (yyval.property_definition) = new_property_definition(ctx, PROPERTY_DEFINITION_SETTER, (yyvsp[-1].literal), (yyvsp[0].expr)); }
#line 3327 "dlls/jscript/parser.tab.c"
    break;

  case 199:
#line 806 "dlls/jscript/parser.y"
                                { (yyval.expr) = new_function_expression(ctx, NULL, (yyvsp[-4].parameter_list), (yyvsp[-1].source_elements), NULL, ctx->begin + (yylsp[-5]), (yylsp[0]) - (yylsp[-5]) + 1); }
#line 3333 "dlls/jscript/parser.tab.c"
    break;

  case 200:
#line 810 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_string_literal(ctx, compiler_alloc_string_len(ctx->compiler, (yyvsp[0].identifier), lstrlenW((yyvsp[0].identifier)))); }
#line 3339 "dlls/jscript/parser.tab.c"
    break;

  case 201:
#line 811 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_string_literal(ctx, (yyvsp[0].str)); }
#line 3345 "dlls/jscript/parser.tab.c"
    break;

  case 202:
#line 812 "dlls/jscript/parser.y"
                                { (yyval.literal) = (yyvsp[0].literal); }
#line 3351 "dlls/jscript/parser.tab.c"
    break;

  case 203:
#line 816 "dlls/jscript/parser.y"
                                { (yyval.identifier) = NULL; }
#line 3357 "dlls/jscript/parser.tab.c"
    break;

  case 204:
#line 817 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3363 "dlls/jscript/parser.tab.c"
    break;

  case 205:
#line 821 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3369 "dlls/jscript/parser.tab.c"
    break;

  case 206:
#line 823 "dlls/jscript/parser.y"
        {
            if(ctx->script->version < SCRIPTLANGUAGEVERSION_ES5) {
                WARN("%s keyword used as an identifier in legacy mode.\n",
                     debugstr_w((yyvsp[0].identifier)));
                set_error(ctx, (yyloc), JS_E_SYNTAX);
                YYABORT;
            }
            (yyval.identifier) = (yyvsp[0].identifier);
        }
#line 3383 "dlls/jscript/parser.tab.c"
    break;

  case 207:
#line 834 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3389 "dlls/jscript/parser.tab.c"
    break;

  case 208:
#line 835 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3395 "dlls/jscript/parser.tab.c"
    break;

  case 209:
#line 836 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3401 "dlls/jscript/parser.tab.c"
    break;

  case 210:
#line 837 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3407 "dlls/jscript/parser.tab.c"
    break;

  case 211:
#line 838 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3413 "dlls/jscript/parser.tab.c"
    break;

  case 212:
#line 839 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3419 "dlls/jscript/parser.tab.c"
    break;

  case 213:
#line 840 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3425 "dlls/jscript/parser.tab.c"
    break;

  case 214:
#line 841 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3431 "dlls/jscript/parser.tab.c"
    break;

  case 215:
#line 842 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3437 "dlls/jscript/parser.tab.c"
    break;

  case 216:
#line 843 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3443 "dlls/jscript/parser.tab.c"
    break;

  case 217:
#line 844 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3449 "dlls/jscript/parser.tab.c"
    break;

  case 218:
#line 845 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3455 "dlls/jscript/parser.tab.c"
    break;

  case 219:
#line 846 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3461 "dlls/jscript/parser.tab.c"
    break;

  case 220:
#line 847 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3467 "dlls/jscript/parser.tab.c"
    break;

  case 221:
#line 848 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3473 "dlls/jscript/parser.tab.c"
    break;

  case 222:
#line 849 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3479 "dlls/jscript/parser.tab.c"
    break;

  case 223:
#line 850 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3485 "dlls/jscript/parser.tab.c"
    break;

  case 224:
#line 851 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3491 "dlls/jscript/parser.tab.c"
    break;

  case 225:
#line 852 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3497 "dlls/jscript/parser.tab.c"
    break;

  case 226:
#line 853 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3503 "dlls/jscript/parser.tab.c"
    break;

  case 227:
#line 854 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3509 "dlls/jscript/parser.tab.c"
    break;

  case 228:
#line 855 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3515 "dlls/jscript/parser.tab.c"
    break;

  case 229:
#line 856 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3521 "dlls/jscript/parser.tab.c"
    break;

  case 230:
#line 857 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3527 "dlls/jscript/parser.tab.c"
    break;

  case 231:
#line 858 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3533 "dlls/jscript/parser.tab.c"
    break;

  case 232:
#line 859 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3539 "dlls/jscript/parser.tab.c"
    break;

  case 233:
#line 860 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3545 "dlls/jscript/parser.tab.c"
    break;

  case 234:
#line 861 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3551 "dlls/jscript/parser.tab.c"
    break;

  case 235:
#line 862 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3557 "dlls/jscript/parser.tab.c"
    break;

  case 236:
#line 863 "dlls/jscript/parser.y"
                                { (yyval.identifier) = (yyvsp[0].identifier); }
#line 3563 "dlls/jscript/parser.tab.c"
    break;

  case 237:
#line 867 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_null_literal(ctx); }
#line 3569 "dlls/jscript/parser.tab.c"
    break;

  case 238:
#line 868 "dlls/jscript/parser.y"
                                { (yyval.literal) = (yyvsp[0].literal); }
#line 3575 "dlls/jscript/parser.tab.c"
    break;

  case 239:
#line 869 "dlls/jscript/parser.y"
                                { (yyval.literal) = (yyvsp[0].literal); }
#line 3581 "dlls/jscript/parser.tab.c"
    break;

  case 240:
#line 870 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_string_literal(ctx, (yyvsp[0].str)); }
#line 3587 "dlls/jscript/parser.tab.c"
    break;

  case 241:
#line 871 "dlls/jscript/parser.y"
                                { (yyval.literal) = parse_regexp(ctx);
                                  if(!(yyval.literal)) YYABORT; }
#line 3594 "dlls/jscript/parser.tab.c"
    break;

  case 242:
#line 873 "dlls/jscript/parser.y"
                                { (yyval.literal) = parse_regexp(ctx);
                                  if(!(yyval.literal)) YYABORT; }
#line 3601 "dlls/jscript/parser.tab.c"
    break;

  case 243:
#line 878 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_boolean_literal(ctx, VARIANT_TRUE); }
#line 3607 "dlls/jscript/parser.tab.c"
    break;

  case 244:
#line 879 "dlls/jscript/parser.y"
                                { (yyval.literal) = new_boolean_literal(ctx, VARIANT_FALSE); }
#line 3613 "dlls/jscript/parser.tab.c"
    break;

  case 245:
#line 880 "dlls/jscript/parser.y"
                                { (yyval.literal) = (yyvsp[0].literal); }
#line 3619 "dlls/jscript/parser.tab.c"
    break;

  case 247:
#line 884 "dlls/jscript/parser.y"
                                { if(!allow_auto_semicolon(ctx)) {YYABORT;} else { ctx->hres = S_OK; ctx->error_loc = -1; } }
#line 3625 "dlls/jscript/parser.tab.c"
    break;

  case 249:
#line 888 "dlls/jscript/parser.y"
                                { set_error(ctx, (yyloc), JS_E_MISSING_LBRACKET); YYABORT; }
#line 3631 "dlls/jscript/parser.tab.c"
    break;

  case 251:
#line 892 "dlls/jscript/parser.y"
                                { set_error(ctx, (yyloc), JS_E_MISSING_RBRACKET); YYABORT; }
#line 3637 "dlls/jscript/parser.tab.c"
    break;

  case 253:
#line 896 "dlls/jscript/parser.y"
                                { set_error(ctx,  (yyloc), JS_E_MISSING_SEMICOLON); YYABORT; }
#line 3643 "dlls/jscript/parser.tab.c"
    break;


#line 3647 "dlls/jscript/parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 898 "dlls/jscript/parser.y"


static BOOL allow_auto_semicolon(parser_ctx_t *ctx)
{
    return ctx->nl || ctx->ptr == ctx->end || *(ctx->ptr-1) == '}';
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size, unsigned loc)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(!stat)
        return NULL;

    stat->type = type;
    stat->loc  = loc;
    stat->next = NULL;

    return stat;
}

static literal_t *new_string_literal(parser_ctx_t *ctx, jsstr_t *str)
{
    literal_t *ret = parser_alloc(ctx, sizeof(literal_t));

    ret->type = LT_STRING;
    ret->u.str = str;

    return ret;
}

static literal_t *new_null_literal(parser_ctx_t *ctx)
{
    literal_t *ret = parser_alloc(ctx, sizeof(literal_t));

    ret->type = LT_NULL;

    return ret;
}

static property_definition_t *new_property_definition(parser_ctx_t *ctx, property_definition_type_t type,
                                                      literal_t *name, expression_t *value)
{
    property_definition_t *ret = parser_alloc(ctx, sizeof(property_definition_t));

    ret->type = type;
    ret->name = name;
    ret->value = value;
    ret->next = NULL;

    return ret;
}

static property_list_t *new_property_list(parser_ctx_t *ctx, property_definition_t *prop)
{
    property_list_t *ret = parser_alloc_tmp(ctx, sizeof(property_list_t));
    ret->head = ret->tail = prop;
    return ret;
}

static property_list_t *property_list_add(parser_ctx_t *ctx, property_list_t *list, property_definition_t *prop)
{
    list->tail = list->tail->next = prop;
    return list;
}

static array_element_t *new_array_element(parser_ctx_t *ctx, int elision, expression_t *expr)
{
    array_element_t *ret = parser_alloc(ctx, sizeof(array_element_t));

    ret->elision = elision;
    ret->expr = expr;
    ret->next = NULL;

    return ret;
}

static element_list_t *new_element_list(parser_ctx_t *ctx, int elision, expression_t *expr)
{
    element_list_t *ret = parser_alloc_tmp(ctx, sizeof(element_list_t));

    ret->head = ret->tail = new_array_element(ctx, elision, expr);

    return ret;
}

static element_list_t *element_list_add(parser_ctx_t *ctx, element_list_t *list, int elision, expression_t *expr)
{
    list->tail = list->tail->next = new_array_element(ctx, elision, expr);

    return list;
}

static argument_t *new_argument(parser_ctx_t *ctx, expression_t *expr)
{
    argument_t *ret = parser_alloc(ctx, sizeof(argument_t));

    ret->expr = expr;
    ret->next = NULL;

    return ret;
}

static argument_list_t *new_argument_list(parser_ctx_t *ctx, expression_t *expr)
{
    argument_list_t *ret = parser_alloc_tmp(ctx, sizeof(argument_list_t));

    ret->head = ret->tail = new_argument(ctx, expr);

    return ret;
}

static argument_list_t *argument_list_add(parser_ctx_t *ctx, argument_list_t *list, expression_t *expr)
{
    list->tail = list->tail->next = new_argument(ctx, expr);

    return list;
}

static catch_block_t *new_catch_block(parser_ctx_t *ctx, const WCHAR *identifier, statement_t *statement)
{
    catch_block_t *ret = parser_alloc(ctx, sizeof(catch_block_t));

    ret->identifier = identifier;
    ret->statement = statement;

    return ret;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, unsigned loc, expression_t *expr, statement_list_t *stat_list)
{
    case_clausule_t *ret = parser_alloc(ctx, sizeof(case_clausule_t));

    ret->expr = expr;
    ret->stat = stat_list ? stat_list->head : NULL;
    ret->loc = loc;
    ret->next = NULL;

    return ret;
}

static case_list_t *new_case_list(parser_ctx_t *ctx, case_clausule_t *case_clausule)
{
    case_list_t *ret = parser_alloc_tmp(ctx, sizeof(case_list_t));

    ret->head = ret->tail = case_clausule;

    return ret;
}

static case_list_t *case_list_add(parser_ctx_t *ctx, case_list_t *list, case_clausule_t *case_clausule)
{
    list->tail = list->tail->next = case_clausule;

    return list;
}

static case_clausule_t *new_case_block(parser_ctx_t *ctx, case_list_t *case_list1,
        case_clausule_t *default_clausule, case_list_t *case_list2)
{
    case_clausule_t *ret = NULL, *iter = NULL, *iter2;
    statement_t *stat = NULL;

    if(case_list1) {
        ret = case_list1->head;
        iter = case_list1->tail;
    }

    if(default_clausule) {
        if(ret)
            iter = iter->next = default_clausule;
        else
            ret = iter = default_clausule;
    }

    if(case_list2) {
        if(ret)
            iter->next = case_list2->head;
        else
            ret = case_list2->head;
    }

    if(!ret)
        return NULL;

    for(iter = ret; iter; iter = iter->next) {
        for(iter2 = iter; iter2 && !iter2->stat; iter2 = iter2->next);
        if(!iter2)
            break;

        while(iter != iter2) {
            iter->stat = iter2->stat;
            iter = iter->next;
        }

        if(stat) {
            while(stat->next)
                stat = stat->next;
            stat->next = iter->stat;
        }else {
            stat = iter->stat;
        }
    }

    return ret;
}

static statement_t *new_block_statement(parser_ctx_t *ctx, unsigned loc, statement_list_t *list)
{
    block_statement_t *ret;

    ret = new_statement(ctx, STAT_BLOCK, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->stat_list = list ? list->head : NULL;

    return &ret->stat;
}

static variable_declaration_t *new_variable_declaration(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *expr)
{
    variable_declaration_t *ret = parser_alloc(ctx, sizeof(variable_declaration_t));

    ret->identifier = identifier;
    ret->expr = expr;
    ret->next = NULL;
    ret->global_next = NULL;

    return ret;
}

static variable_list_t *new_variable_list(parser_ctx_t *ctx, variable_declaration_t *decl)
{
    variable_list_t *ret = parser_alloc_tmp(ctx, sizeof(variable_list_t));

    ret->head = ret->tail = decl;

    return ret;
}

static variable_list_t *variable_list_add(parser_ctx_t *ctx, variable_list_t *list, variable_declaration_t *decl)
{
    list->tail = list->tail->next = decl;

    return list;
}

static statement_t *new_var_statement(parser_ctx_t *ctx, unsigned loc, variable_list_t *variable_list)
{
    var_statement_t *ret;

    ret = new_statement(ctx, STAT_VAR, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->variable_list = variable_list->head;

    return &ret->stat;
}

static statement_t *new_expression_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr)
{
    expression_statement_t *ret;

    ret = new_statement(ctx, STAT_EXPR, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;

    return &ret->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr,
                                     statement_t *if_stat, statement_t *else_stat)
{
    if_statement_t *ret;

    ret = new_statement(ctx, STAT_IF, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->if_stat = if_stat;
    ret->else_stat = else_stat;

    return &ret->stat;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, unsigned loc, BOOL dowhile, expression_t *expr, statement_t *stat)
{
    while_statement_t *ret;

    ret = new_statement(ctx, STAT_WHILE, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->do_while = dowhile;
    ret->expr = expr;
    ret->statement = stat;

    return &ret->stat;
}

static statement_t *new_for_statement(parser_ctx_t *ctx, unsigned loc, variable_list_t *variable_list, expression_t *begin_expr,
        expression_t *expr, unsigned expr_loc, expression_t *end_expr, unsigned end_loc, statement_t *statement)
{
    for_statement_t *ret;

    ret = new_statement(ctx, STAT_FOR, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->variable_list = variable_list ? variable_list->head : NULL;
    ret->begin_expr = begin_expr;
    ret->expr = expr;
    ret->expr_loc = expr_loc;
    ret->end_expr = end_expr;
    ret->end_loc = end_loc;
    ret->statement = statement;

    return &ret->stat;
}

static statement_t *new_forin_statement(parser_ctx_t *ctx, unsigned loc, variable_declaration_t *variable, expression_t *expr,
        expression_t *in_expr, statement_t *statement)
{
    forin_statement_t *ret;

    ret = new_statement(ctx, STAT_FORIN, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->variable = variable;
    ret->expr = expr;
    ret->in_expr = in_expr;
    ret->statement = statement;

    return &ret->stat;
}

static statement_t *new_continue_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier)
{
    branch_statement_t *ret;

    ret = new_statement(ctx, STAT_CONTINUE, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->identifier = identifier;

    return &ret->stat;
}

static statement_t *new_break_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier)
{
    branch_statement_t *ret;

    ret = new_statement(ctx, STAT_BREAK, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->identifier = identifier;

    return &ret->stat;
}

static statement_t *new_return_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr)
{
    expression_statement_t *ret;

    ret = new_statement(ctx, STAT_RETURN, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;

    return &ret->stat;
}

static statement_t *new_with_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr, statement_t *statement)
{
    with_statement_t *ret;

    ret = new_statement(ctx, STAT_WITH, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->statement = statement;

    return &ret->stat;
}

static statement_t *new_labelled_statement(parser_ctx_t *ctx, unsigned loc, const WCHAR *identifier, statement_t *statement)
{
    labelled_statement_t *ret;

    ret = new_statement(ctx, STAT_LABEL, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->identifier = identifier;
    ret->statement = statement;

    return &ret->stat;
}

static statement_t *new_switch_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr, case_clausule_t *case_list)
{
    switch_statement_t *ret;

    ret = new_statement(ctx, STAT_SWITCH, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->case_list = case_list;

    return &ret->stat;
}

static statement_t *new_throw_statement(parser_ctx_t *ctx, unsigned loc, expression_t *expr)
{
    expression_statement_t *ret;

    ret = new_statement(ctx, STAT_THROW, sizeof(*ret), loc);
    if(!ret)
        return NULL;

    ret->expr = expr;

    return &ret->stat;
}

static statement_t *new_try_statement(parser_ctx_t *ctx, statement_t *try_statement,
        catch_block_t *catch_block, statement_t *finally_statement, unsigned finally_loc)
{
    try_statement_t *ret;

    ret = new_statement(ctx, STAT_TRY, sizeof(*ret), try_statement->loc);
    if(!ret)
        return NULL;

    ret->try_statement = try_statement;
    ret->catch_block = catch_block;
    ret->finally_statement = finally_statement;
    ret->finally_loc = finally_loc;

    return &ret->stat;
}

static parameter_t *new_parameter(parser_ctx_t *ctx, const WCHAR *identifier)
{
    parameter_t *ret = parser_alloc(ctx, sizeof(parameter_t));

    ret->identifier = identifier;
    ret->next = NULL;

    return ret;
}

static parameter_list_t *new_parameter_list(parser_ctx_t *ctx, const WCHAR *identifier)
{
    parameter_list_t *ret = parser_alloc_tmp(ctx, sizeof(parameter_list_t));

    ret->head = ret->tail = new_parameter(ctx, identifier);

    return ret;
}

static parameter_list_t *parameter_list_add(parser_ctx_t *ctx, parameter_list_t *list, const WCHAR *identifier)
{
    list->tail = list->tail->next = new_parameter(ctx, identifier);

    return list;
}

static expression_t *new_function_expression(parser_ctx_t *ctx, const WCHAR *identifier, parameter_list_t *parameter_list,
    source_elements_t *source_elements, const WCHAR *event_target, const WCHAR *src_str, DWORD src_len)
{
    function_expression_t *ret = new_expression(ctx, EXPR_FUNC, sizeof(*ret));

    ret->identifier = identifier;
    ret->parameter_list = parameter_list ? parameter_list->head : NULL;
    ret->source_elements = source_elements;
    ret->event_target = event_target;
    ret->src_str = src_str;
    ret->src_len = src_len;
    ret->next = NULL;

    return &ret->expr;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *ret = parser_alloc(ctx, size ? size : sizeof(*ret));

    ret->type = type;

    return ret;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type,
       expression_t *expression1, expression_t *expression2)
{
    binary_expression_t *ret = new_expression(ctx, type, sizeof(*ret));

    ret->expression1 = expression1;
    ret->expression2 = expression2;

    return &ret->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *expression)
{
    unary_expression_t *ret = new_expression(ctx, type, sizeof(*ret));

    ret->expression = expression;

    return &ret->expr;
}

static expression_t *new_conditional_expression(parser_ctx_t *ctx, expression_t *expression,
       expression_t *true_expression, expression_t *false_expression)
{
    conditional_expression_t *ret = new_expression(ctx, EXPR_COND, sizeof(*ret));

    ret->expression = expression;
    ret->true_expression = true_expression;
    ret->false_expression = false_expression;

    return &ret->expr;
}

static expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *expression, const WCHAR *identifier)
{
    member_expression_t *ret = new_expression(ctx, EXPR_MEMBER, sizeof(*ret));

    ret->expression = expression;
    ret->identifier = identifier;

    return &ret->expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, expression_t *expression, argument_list_t *argument_list)
{
    call_expression_t *ret = new_expression(ctx, EXPR_NEW, sizeof(*ret));

    ret->expression = expression;
    ret->argument_list = argument_list ? argument_list->head : NULL;

    return &ret->expr;
}

static expression_t *new_call_expression(parser_ctx_t *ctx, expression_t *expression, argument_list_t *argument_list)
{
    call_expression_t *ret = new_expression(ctx, EXPR_CALL, sizeof(*ret));

    ret->expression = expression;
    ret->argument_list = argument_list ? argument_list->head : NULL;

    return &ret->expr;
}

static int parser_error(unsigned *loc, parser_ctx_t *ctx, const char *str)
{
    if(ctx->error_loc == -1)
        ctx->error_loc = *loc;
    if(ctx->hres == S_OK)
        ctx->hres = JS_E_SYNTAX;
    WARN("%s: %s\n", debugstr_w(ctx->begin + *loc), str);
    return 0;
}

static void set_error(parser_ctx_t *ctx, unsigned loc, HRESULT error)
{
    ctx->hres = error;
    ctx->error_loc = loc;
}

static BOOL explicit_error(parser_ctx_t *ctx, void *obj, WCHAR next)
{
    if(obj || *(ctx->ptr-1)==next) return TRUE;

    set_error(ctx, ctx->ptr - ctx->begin /* FIXME */, JS_E_SYNTAX);
    return FALSE;
}


static expression_t *new_identifier_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    identifier_expression_t *ret = new_expression(ctx, EXPR_IDENT, sizeof(*ret));

    ret->identifier = identifier;

    return &ret->expr;
}

static expression_t *new_array_literal_expression(parser_ctx_t *ctx, element_list_t *element_list, int length)
{
    array_literal_expression_t *ret = new_expression(ctx, EXPR_ARRAYLIT, sizeof(*ret));

    ret->element_list = element_list ? element_list->head : NULL;
    ret->length = length;

    return &ret->expr;
}

static expression_t *new_prop_and_value_expression(parser_ctx_t *ctx, property_list_t *property_list)
{
    property_value_expression_t *ret = new_expression(ctx, EXPR_PROPVAL, sizeof(*ret));

    ret->property_list = property_list ? property_list->head : NULL;

    return &ret->expr;
}

static expression_t *new_literal_expression(parser_ctx_t *ctx, literal_t *literal)
{
    literal_expression_t *ret = new_expression(ctx, EXPR_LITERAL, sizeof(*ret));

    ret->literal = literal;

    return &ret->expr;
}

static source_elements_t *new_source_elements(parser_ctx_t *ctx)
{
    source_elements_t *ret = parser_alloc(ctx, sizeof(source_elements_t));

    memset(ret, 0, sizeof(*ret));

    return ret;
}

static source_elements_t *source_elements_add_statement(source_elements_t *source_elements, statement_t *statement)
{
    if(source_elements->statement_tail)
        source_elements->statement_tail = source_elements->statement_tail->next = statement;
    else
        source_elements->statement = source_elements->statement_tail = statement;

    return source_elements;
}

static statement_list_t *new_statement_list(parser_ctx_t *ctx, statement_t *statement)
{
    statement_list_t *ret =  parser_alloc_tmp(ctx, sizeof(statement_list_t));

    ret->head = ret->tail = statement;

    return ret;
}

static statement_list_t *statement_list_add(statement_list_t *list, statement_t *statement)
{
    list->tail = list->tail->next = statement;

    return list;
}

void parser_release(parser_ctx_t *ctx)
{
    script_release(ctx->script);
    heap_pool_free(&ctx->heap);
    heap_free(ctx);
}

HRESULT script_parse(script_ctx_t *ctx, struct _compiler_ctx_t *compiler, bytecode_t *code, const WCHAR *delimiter, BOOL from_eval,
        parser_ctx_t **ret)
{
    parser_ctx_t *parser_ctx;
    heap_pool_t *mark;
    HRESULT hres;

    parser_ctx = heap_alloc_zero(sizeof(parser_ctx_t));
    if(!parser_ctx)
        return E_OUTOFMEMORY;

    parser_ctx->error_loc = -1;
    parser_ctx->is_html = delimiter && !wcsicmp(delimiter, L"</script>");

    parser_ctx->begin = parser_ctx->ptr = code->source;
    parser_ctx->end = parser_ctx->begin + lstrlenW(parser_ctx->begin);

    script_addref(ctx);
    parser_ctx->script = ctx;

    mark = heap_pool_mark(&ctx->tmp_heap);
    heap_pool_init(&parser_ctx->heap);

    parser_ctx->compiler = compiler;
    parser_parse(parser_ctx);
    parser_ctx->compiler = NULL;

    heap_pool_clear(mark);
    hres = parser_ctx->hres;
    if(FAILED(hres)) {
        const WCHAR *line_start = code->source + parser_ctx->error_loc, *line_end = line_start;
        jsstr_t *line_str;

        while(line_start > code->source && line_start[-1] != '\n')
            line_start--;
        while(*line_end && *line_end != '\n')
            line_end++;
        line_str = jsstr_alloc_len(line_start, line_end - line_start);

        WARN("parser failed around %s in line %s\n",
             debugstr_w(parser_ctx->begin+20 > parser_ctx->ptr ? parser_ctx->begin : parser_ctx->ptr-20),
             debugstr_jsstr(line_str));

        throw_error(ctx, hres, NULL);
        set_error_location(ctx->ei, code, parser_ctx->error_loc, IDS_COMPILATION_ERROR, line_str);
        parser_release(parser_ctx);
        if(line_str)
            jsstr_release(line_str);
        return DISP_E_EXCEPTION;
    }

    *ret = parser_ctx;
    return S_OK;
}
